#!/usr/bin/env python
from pymongo import MongoClient, ASCENDING, DESCENDING

from bson.objectid import ObjectId

class MongoModel(object):
  def __init__(self, dbname="luminance", host="localhost", port=27017, user=None, password=None):
    if user:
      self.client = MongoClient('mongodb://%s:%s@%s:%d'%(user, password, host, port))
    else:
      self.client = MongoClient('mongodb://%s:%d'%(host, port))
    self.db = self.client[dbname]
    self.camera = self.db.camera
    self.project = self.db.project
    self.capture = self.db.capture
    
  def filter_data(self, data):
    out = {}
    if data:
      for k,v in data.iteritems():
        if not v:
          continue
        if type(v) == dict:
          o = self.filter_data(v)
          if len(o) > 0:
            out[k] = o
        else:
          out[k] = v
    return out
      
  
  def camera_save(self, data):
    return str(self.camera.insert_one(self.filter_data(data)).inserted_id)

  def camera_update(self,camera,data):
    camid = self.camera_get({"name":camera})["_id"]
    print camid
    
    return str(self.camera.update({"_id":camid}, {"$set": data}))
  
  def camera_get(self, params):
    return self.camera.find_one(params)
    
  
  def project_save(self, data):
    print "Saving project"
    return str(self.project.insert_one(self.filter_data(data)).inserted_id)
    
  
  def project_get(self, params):
    ret = self.project.find_one(params)
    print ret
    return ret
    
  def project_get_all(self):
    ret = list(self.project.find().sort("capture_start",DESCENDING))
    return  ret
      
  def capture_save(self, data):
    return str(self.capture.insert_one(self.filter_data(data)).inserted_id)
  
  def capture_get(self, param=None):
    return list(self.capture.find(param))
  
  def getOIDfromString(self, soid):
    return ObjectId(soid)
