from PIL import Image
from reportlab.lib.enums import TA_JUSTIFY
from reportlab.lib.pagesizes import letter, A4
from reportlab.platypus import SimpleDocTemplate, Paragraph, Spacer, KeepTogether
from reportlab.platypus import Image as RImage
from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
from reportlab.lib.units import inch
import image_analysis 

line = (0,0,1000,1000)
point = (2000,2000)
doc = SimpleDocTemplate("./pdf.pdf",pagesize=A4)
width, height = A4
styles=getSampleStyleSheet()
styles.add(ParagraphStyle(name='Justify', alignment=TA_JUSTIFY))
Story=[]
Story.append(Paragraph("Luminance analysis", styles["Title"])) 
Story.append(Paragraph("Project name:", styles["h1"])) 
Story.append(Paragraph("Project details", styles["h2"])) 
Story.append(Paragraph("Date: ", styles["Normal"])) 
Story.append(Paragraph("Camera: ", styles["Normal"])) 
Story.append(Paragraph("Description: ", styles["Normal"])) 
Story.append(Spacer(1, 12))
Story.append(Paragraph("Capture", styles["h2"])) 
img_path = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.tiff'
img_out = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.report.jpeg'

image_analysis.write_report_img(img_path, img_out,line, point)
Story.append(RImage(img_out,width='450', height='350',kind='proportional')) 
Story.append(Paragraph("Luminance", styles["h2"])) 


img_path = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.luminance.tiff'
img_out = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.luminance.report.jpeg'
image_analysis.write_report_img(img_path, img_out,line, point)
Story.append(RImage(img_out,width='450', height='350',kind='proportional')) 

Story.append(Spacer(1, 12))
img_path = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.luminance.tiff.scale.png'
Story.append(RImage(img_path,width='450', height='350',kind='proportional')) 

Story.append(Spacer(1, 12))
img_path = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.histogram.png'
Story.append(RImage(img_path,width='450', height='350',kind='proportional'))

Story.append(Spacer(1, 12))
img_path = '/home/pi/CAPTURE/583383aa74fece0ed9035bc5/Canon_EOS_600D/2.line.histogram.png'
Story.append(RImage(img_path,width='450', height='350',kind='proportional'))

Story.append(Paragraph("Analysis", styles["h2"])) 
Story.append(Paragraph("Min value: ", styles["Normal"])) 
Story.append(Paragraph("Max value: ", styles["Normal"])) 
Story.append(Paragraph("Avg value: ", styles["Normal"])) 
Story.append(Paragraph("Histogram", styles["h3"])) 
doc.build(Story)
