// this file provides a list of unbundled files that
// need to be included when exporting the application
// for production.
module.exports = {
  'list': [
    'index.html',
    'config.js',
    'favicon.ico',
    'LICENSE',
    "jspm_packages/npm/bluebird@3.4.1/js/browser/bluebird.min.js",
    'jspm_packages/system.js',
    'jspm_packages/system-polyfills.js',
    'jspm_packages/system-csp-production.js',
    'jspm_packages/npm/moment@2.15.2.js',
    'jspm_packages/npm/moment@2.15.2/moment.js',
    'jspm_packages/npm/jquery-datetimepicker@2.5.4.js',
    'jspm_packages/npm/jquery-datetimepicker@2.5.4/build/jquery.datetimepicker.full.min.js',
    'jspm_packages/npm/guillotine@1.3.1.js',
    'jspm_packages/npm/guillotine@1.3.1/js/jquery.guillotine.js',
    'jspm_packages/github/systemjs/plugin-css@0.1.32.js',
    'jspm_packages/github/systemjs/plugin-css@0.1.32/css.js',
    'jspm_packages/*',
    'jspm_packages/github/systemjs/plugin-text@0.0.8.js',
    'jspm_packages/github/systemjs/plugin-text@0.0.8/text.js',
    'jspm_packages/github/MarcScheib/aurelia-notify@0.7.0/bs-notification.html',
    'jspm_packages/github/systemjs/*',
    'styles/styles.css',
    'src/loading.gif',
    'src/loading-white.gif',
  ],
  // this section lists any jspm packages that have
  // unbundled resources that need to be exported.
  // these files are in versioned folders and thus
  // must be 'normalized' by jspm to get the proper
  // path.
  'normalize': [
    [
      // include font-awesome.css and its fonts files
      'font-awesome', [
        '/css/font-awesome.min.css',
        '/fonts/*'
      ]
    ], [
      // include bootstrap's font files
      'bootstrap', [
        '/fonts/*'
      ]
    ], [
      'bluebird', [
        '/js/browser/bluebird.min.js'
      ]
  ],
    [
      'jquery-datetimepicker', [
        '/jquery.datetimepicker.css'
      ]
    ],
    [
      'guillotine', [
        '/css/jquery.guillotine.css'
      ]
    ],
    [
      'aurelia-notify', [
        '/style.css'
      ]
    ],
  ]
};
