import {inject} from 'aurelia-framework';
import {EventAggregator} from 'aurelia-event-aggregator';
import {RestCaptureContolAPI} from './control-api';
import {areEqual} from './utility';
import {ProjectConfig} from './containers/project-config';


@inject(ProjectConfig, EventAggregator)
export class CaptureMain {

  constructor(private project: ProjectConfig, private ea: EventAggregator) {

  }
  selectedCameraView;
  statusSubscription;
  status;
  captureError;

  activate(){

  }
  attached(){
      this.captureError = false;
      this.statusSubscription = this.ea.subscribe('status', status => {
          console.log("Master says", status);
          this.handleStatusUpdate(status);
      });
  }

  handleStatusUpdate(status){
      this.status = status
      if (status.project.started || status.project.waiting){
          if (!this.selectedCameraView){
              this.setCameraView(status.project.config.cameras[0])
          }
          //console.log(status.project.cameras[this.selectedCameraView].thumbnail)
          if(status.project.cameras){
              if(status.project.cameras[this.selectedCameraView].thumbnail == "-1"){
                  this.captureError = true;
              }
              else{
                  this.captureError = false;
              }
          }

          
      }

  }

  setCameraView(camera){
      console.log("Setting view to "+camera)
      this.selectedCameraView =  camera;
      console.log(this.project.cameras);
      return true;

  }
  detached(){
      this.statusSubscription.dispose()
  }
}
