import {inject, customAttribute} from 'aurelia-framework';
import * as Moment from 'moment';
import 'jquery';
import 'jquery-datetimepicker';
import 'jquery-datetimepicker/jquery.datetimepicker.css!';

@customAttribute('datepicker')
@inject(Element)
export class DatePicker {
  constructor(private element) {
  }

  attached() {
    ($(this.element) as any).datetimepicker({ validateOnBlur:true, minDate:0, defaultDate:new Date(), todayButton: true, format: "d.m.y H:i"})
      .on('change', e => fireEvent(e.target, 'input'));
  }

  detached() {
    // remove it in here if possible!
  }
}

function fireEvent(element, name) {
  var event = document.createEvent('Event');
  event.initEvent(name, true, true);
  element.dispatchEvent(event);
}
