import {inject, customAttribute, bindable, Parent} from 'aurelia-framework';
import {EventAggregator} from 'aurelia-event-aggregator';
import 'jquery';

import 'guillotine';
import 'guillotine/css/jquery.guillotine.css!';
//import * as Moment from 'moment';

//import 'jquery-datetimepicker';
//import 'jquery-datetimepicker/jquery.datetimepicker.css!';

@customAttribute('guillotine')
@inject(Element, EventAggregator)
export class Guilotine {
  @bindable onChange: any;
  @bindable onLineUpdated: any;
  @bindable onPointSelected: any;
  ea: EventAggregator;
  msgSubscription: any;
  lockSubscription: any;
  uiLock : boolean;

  constructor(private element, private eventAggregator) {
      this.ea = eventAggregator;
      this.uiLock = true;
  }

  convertImageToCanvas(image, scale) {
    var canvas = document.createElement("canvas");
    canvas.width = image.width;
    canvas.height = image.height;
    let context = canvas.getContext("2d")
    //context.drawImage(image, 0, 0);
    context.save()
    context.scale(scale, scale)
    context.drawImage(image, 0, 0);
    context.restore()
    return canvas;
  }

  setLock(lock){
      if(lock){
          ($(this.element) as any).guillotine('disable');
      }
      else{
          ($(this.element) as any).guillotine('enable');
      }
      this.uiLock = lock
  }

  attached() {



      console.log("Attaching Guil");
      let el = ($(this.element) as any);



      let parent = this;
      el.one('load', function(){
        // Initialize plugin (with custom event)



        console.log(el.attr('id'));
        let ar = el.width()/el.height();
        let guill_height = 400;
        let guill_width = guill_height*ar;

        //console.log(el.width, ar, guill_width, guill_height);
        ($('.frame') as any).css({'width': guill_width, 'height': guill_height})

        el.guillotine({width: guill_width, height: guill_height, onChange:  (data, action) => {
                    parent.ea.publish('coordsUpdated', el.guillotine('getData'));
                    if (parent.onChange) {
                            parent.onChange({
                                d:el.guillotine('getData')
                            })
                    }
                    else{
                        console.log("onUpdate doesn't exist")
                    }
            }});

            el.guillotine('fit');
            el.guillotine('center');
            parent.msgSubscription = parent.eventAggregator.subscribe('luminaceReady', d => {console.log("Lum says", d); parent.ea.publish('coordsUpdated', el.guillotine('getData'));});
            parent.msgSubscription = parent.eventAggregator.subscribe('uiLock', lock => {console.log("Gill: Parent says lock is", lock); parent.setLock(lock)});
            //parent.lockSubscription = parent.ea.subscribe('uiLock', d => {console.log("Gill: Parent says lock is ", d);parent.uiLock = d})

            ($('#zoom_in') as any).click(function(e){
               e.preventDefault();
               el.guillotine('zoomIn');
            });

            ($('#zoom_out') as any).click(function(e){
               e.preventDefault();
               el.guillotine('zoomOut');
            });

            ($('#fit') as any).click(function(e){
               e.preventDefault();
               el.guillotine('fit');
               el.guillotine('center');
            });

            el.on('wheel mousewheel',  function(e){
                let delta;
                if (e.originalEvent.wheelDelta !== undefined)
                    delta = e.originalEvent.wheelDelta;
                else
                    delta = e.originalEvent.deltaY * -1;

                    if(delta > 0) {
                        el.guillotine('zoomIn');
                    }
                    else{
                        el.guillotine('zoomOut');
                    }
                });







        });
      if (el.prop('complete')) el.trigger('load');


  }

  detached() {
      ($(this.element) as any).guillotine('remove');
    // remove it in here if possible!
  }

  lineDistance(x, y, x0, y0){
      return Math.sqrt((x -= x0) * x + (y -= y0) * y);
  }

  drawLine(elemName, line) {
    var angle = Math.atan2(line.b.y - line.a.y, line.b.x - line.a.x) * 180 / Math.PI;
    var distance = this.lineDistance(line.a.x, line.a.y, line.b.x, line.b.y);

    console.log(line.a);

    // Set Angle
    ($(elemName)as any).css('transform', 'rotate(' + angle + 'deg)');

    // Set Width
    ($(elemName)as any).css('width', distance + 'px');

    // Set Position
    ($(elemName)as any).css('position', 'absolute');
    if(line.b.x < line.a.x) {
      console.log("version A");
      if(line.b.y < line.a.y) {
          console.log("Ay > By");
          ($(elemName)as any).offset({top: line.b.y, left: line.b.x});
      }else{
          console.log("Ay < By");
          ($(elemName)as any).offset({top: line.a.y, left: line.b.x});
      }

    } else {

        console.log("version B");
        if(line.b.y < line.a.y) {
                ($(elemName)as any).offset({top: line.b.y, left: line.a.x});
        }
        else{
            ($(elemName)as any).offset({top: line.a.y, left: line.a.x});
        }

  }
  }
}






function fireEvent(element, name) {
  var event = document.createEvent('Event');
  event.initEvent(name, true, true);
  element.dispatchEvent(event);
}
