import {HttpClient} from 'aurelia-http-client';
let capture_url = "project-capture"
let analyze_url = "analyze"
let preview_url = "preview"
let calibrate_url = "calibrate"
let controlClient =  new HttpClient();

controlClient.configure(x => {
  x.withBaseUrl('http://'+window.location.hostname+':4444');
});







export class RestCaptureContolAPI {
  getStatus(){
    return controlClient.createRequest(capture_url).asGet().send().then(data => data.content);
    //ERROR CODE HANDLING
  }

  setConfig(config){
    return controlClient.createRequest(capture_url).asPost().withContent(JSON.stringify(config)).send();
  }

  start(project){
    console.log("Starting project")
    return controlClient.createRequest(capture_url).asPut().withContent(JSON.stringify(project)).send();
  }

  stop(project){
    return controlClient.createRequest(capture_url)
    .asDelete()
    .send();
    //ERROR CODE HANDLING
  }
}

export class RestAnalyzeControlAPI {
  analyze(projectid, camera, photoid, action, coords, calibration=null){
    return controlClient.createRequest(analyze_url)
           .withContent({"projectid": projectid,"camera": camera, "photoid": photoid, "action": action, "coords": coords, "calibration": calibration})
           .asPut().send().then(data => data.content);
  }
}

export class RestPreviewAPI {
  preview(camera){
    return controlClient.createRequest(preview_url)
           .withParams({"camera": camera})
           .asGet().send().then(data => data.content);
  }
}

export class RestCalibrateAPI {
  calibrate(camera){
    return controlClient.createRequest(calibrate_url)
           .withParams({"camera": camera})
           .asGet().send().then(data => data.content);
  }
}

export class ProjectsAPI {
  getProjects(){
    return controlClient.createRequest('projects')
    .asGet()
    .send()
    .then(data => data);
    //ERROR CODE HANDLING
  }

  getProject(key){
    return controlClient.createRequest('projects')
    .asGet()
    .withParams({ 'k': key })
    .send()
    .then(data => data);
    //ERROR CODE HANDLING
  }
}
