import {Aurelia, LogManager} from 'aurelia-framework'
import {ConsoleAppender} from 'aurelia-logging-console';

//Configure Bluebird Promises.
//Note: You may want to use environment-specific configuration.
(<any>Promise).config({
  warnings: {
    wForgottenReturn: false
  }
});

LogManager.addAppender(new ConsoleAppender());
LogManager.setLevel(LogManager.logLevel.debug);

export function configure(aurelia: Aurelia) {
  aurelia.use
    .standardConfiguration()
    .plugin('component/globals')
    //.plugin('aurelia-tabs')
    .plugin('aurelia-notify', settings => {
      settings.timeout = 5000;
      settings.containerSelector = '.notification';
      settings.append = false;
      settings.limit = 3;
    });

  aurelia.start().then(() => aurelia.setRoot());
}
