import {inject} from 'aurelia-framework';
import {ProjectsAPI} from './control-api';
import {NotificationService} from 'aurelia-notify';

@inject(ProjectsAPI, NotificationService)
export class Project {

  project: Object;
  images: Object;
  selectedCameraView;
  loading: boolean;
  constructor(private projects_api: ProjectsAPI, private notificationService : NotificationService) {}

  handleError(e, msg=null){
      this.loading = false;
      this.notificationService.danger("Error while fetching data from server.")
      console.error(e);
  }

  activate(params) {
      this.loading = true;
      this.projects_api.getProject(params.id).then(data =>
        {
            this.images = Object();
            this.project = JSON.parse(data.content.data);
            console.log(this.project)
            for (var camera in this.project['captures']){
                if (!this.selectedCameraView){
                    this.selectedCameraView = camera;
                }
                this.images[camera] = []
                console.log("camdata:", this.project['captures'][camera])
                for (var capturedata in this.project['captures'][camera]){
                    this.project['captures'][camera][capturedata]['img'] = this.project['captures'][camera][capturedata]['thumbnail'];
                    this.images[camera].push(this.project['captures'][camera][capturedata])
                    console.log("capturedata:", this.project['captures'][camera][capturedata])

                }

            }
            this.loading = false;
            this.notificationService.success("Project data successfully loaded");
            //console.log(this.images);
        }, e => this.handleError(e));
  }

  created(){

  }

  set_camera_view(camera){
      console.log("Setting view to "+camera)
      this.selectedCameraView =  camera;
      return false;
  }

  domouseover(capture, idx){
      this.images[capture['camera_name']][idx]['img'] = this.images[capture['camera_name']][idx]['luminance']
      //console.log(this.images[capture['camera_name']])
      //console.log(this.images[capture['camera_name']]['img'])
  }

  domouseout(capture, idx){
      this.images[capture['camera_name']][idx]['img'] = this.images[capture['camera_name']][idx]['thumbnail']
  }

}
