import {inject} from 'aurelia-framework';
import {NotificationService} from 'aurelia-notify';
import {ProjectsAPI} from './control-api';

@inject(ProjectsAPI, NotificationService)
export class Projects {

  projects: Object;
  loading: boolean;
  constructor(private projects_api: ProjectsAPI, private notificationService : NotificationService) {}

  handleError(e, msg=null){
      this.loading = false;
      this.notificationService.danger("Error while fetching data from server.")
      console.error(e);
  }

  created(){
    this.loading = true;
    //this.notificationService.info("Fetching projects data from the server")
    this.projects_api.getProjects().then(data => {
        this.projects = JSON.parse(data.content.data)
        this.loading = false;
        this.notificationService.success("Projects data successfully loaded")
    }, e => this.handleError(e))
  }

}
